REM **************************************************************************
REM **************************************************************************
REM **************************************************************************
REM **************************************************************************
REM **********                                                      **********
REM **********                                                      **********
REM **********           COURS DE PROGRAMMATION EN QBASIC           **********
REM **********               par PHILIPPE-HENRY MARCY               **********
REM **********           http://membres.lycos.fr/firesnk/           **********
REM **********                                                      **********
REM **********                                                      **********
REM **************************************************************************
REM **************************************************************************
REM **********                                                      **********
REM **********                                                      **********
REM **********                EXEMPLE DE PROGRAMME :                **********
REM **********                   JEU DE VAISSEAUX                   **********
REM **********                                                      **********
REM **********                                                      **********
REM **************************************************************************
REM **************************************************************************
REM **************************************************************************
REM **************************************************************************





REM **************************************************************************
REM **************************************************************************
REM ****                                                                  ****
REM ****                           INITIALISATION                         ****
REM ****                                                                  ****
REM **************************************************************************
REM **************************************************************************


REM ********** Dclaration des variables images **********

                         '|-------------------------------------------------|
                         '| LARGEUR | HAUTEUR |    TAILLE VARIABLE IMAGE    |
                         '|-------------------------------------------------|
DIM FondVaiss(276)       '|    41   |    46   | Taille = (  41 / 8  ) * 46  |
                         '|         |         |        = (5.125 -> 6) * 46  |
                         '|         |         |        = 276                |
                         '|-------------------------------------------------|
DIM FondVE1.1(63)        '|    23   |    21   | Taille = (  23 / 8  ) * 21  |
DIM FondVE1.2(63)        '|         |         |        = (2.875 -> 3) * 21  |
DIM FondVE1.3(63)        '|         |         |        = 63                 |
                         '|-------------------------------------------------|
DIM FondVE2.1(85)        '|    33   |    17   | Taille = (  33 / 8  ) * 17  |
DIM FondVE2.2(85)        '|         |         |        = (4.125 -> 5) * 17  |
DIM FondVE2.3(85)        '|         |         |        = 85                 |
                         '|-------------------------------------------------|
DIM FondLaser(360)       '|     1   |   360   | Taille = (   1 / 8  ) * 360 |
                         '|         |         |        = (0.125 -> 1) * 360 |
                         '|         |         |        = 360                |
                         '|-------------------------------------------------|
DIM FondBoom1(185)       '|    37   |    37   | Taille = (  37 / 8  ) * 37  |
DIM FondBoom2(185)       '|         |         |        = (4.625 -> 5) * 37  |
DIM FondBoom3(185)       '|         |         |        = 185                |
DIM FondBoom4(185)       '|-------------------------------------------------|
DIM FondBoom5(185)
DIM FondBoom6(185)


REM ********** Dclaration des variables tableaux **********
DIM ActVE(1 TO 2, 1 TO 3)      'Indique si les vaisseaux ennemis sont actifs
DIM XVE(1 TO 2, 1 TO 3)        'Coordonnes des vaisseaux ennemis
DIM YVE(1 TO 2, 1 TO 3)
DIM LnVE(1 TO 2, 1 TO 3)       'Lignes occupes par les vaisseaux ennemis
DIM DirVE(1 TO 2, 1 TO 3)      'Direction des vaisseaux ennemis
DIM VitVE(1 TO 2, 1 TO 3)      'Vitesse des vaisseaux ennemis
DIM VieVE(1 TO 2, 1 TO 3)      'Points de vie des vaisseaux ennemis
DIM CoulsVE(1 TO 2, 1 TO 3)    'Gamme de couleurs des vaisseaux ennemis

DIM XBoom(1 TO 6)              'Coordonnes des explosions
DIM YBoom(1 TO 6)
DIM LnBoom(1 TO 6)             'Lignes occupes par les explosions
DIM CmptBoom(1 TO 6)           'Temps restant avant que l'explosion disparaisse

DIM LnOccup(1 TO 8)            'Indique si les lignes sont occupes par des
                               '  vaisseaux ennemis


REM ********** Dfinition des constantes **********
REM ** Couleurs du vaisseau principal **
CONST CoulCoque = 3     'Coque :                                    Cyan
CONST CoulCR = 8        'Canons, racteurs et cabine radar :        Gris fonc
CONST CoulCable = 0     'Cbles d'alimentation des canons laser
                        '  et tiges du radar :                      Noir
CONST CoulVCock = 1     'Vitres du cockpit :                        Bleu fonc
CONST CoulBarre = 15    'Barres de soutien des vitres du cockpit :  Blanc
CONST CoulRadar = 10    'Parabole du radar :                        Vert clair
CONST CoulTige = 4      'Tiges des canons laser latraux :          Rouge

REM ** Autres constantes **
CONST YVaiss = 400       'Ordonne du vaisseau principal
DIM XMaxVE(1 TO 2)       'Abscisse maximale des vaisseaux ennemis
XMaxVE(1) = 617          'Vaisseaux de type 1
XMaxVE(2) = 607          '____________ type 2


REM ********** Gnrateur de nombres alatoires **********
RANDOMIZE TIMER


REM ********** Branchement vers la partie principale **********
GOTO Present





REM **************************************************************************
REM **************************************************************************
REM ****                                                                  ****
REM ****                           SOUS-ROUTINES                          ****
REM ****                                                                  ****
REM **************************************************************************
REM **************************************************************************


REM ***********************
REM ** Dessin des images **
REM ***********************

REM ********** Vaisseau principal **********
DessVaiss:
    REM ** Coque **
    LINE (X, Y + 40)-(X + 40, Y + 40), CoulCoque
    LINE (X, Y + 40)-(X + 5, Y + 30), CoulCoque
    LINE (X + 40, Y + 40)-(X + 35, Y + 30), CoulCoque
    CIRCLE (X + 11, Y + 30), 12, CoulCoque, 1.57, 3.14, 2
    CIRCLE (X + 29, Y + 30), 12, CoulCoque, 0, 1.57, 2
    LINE (X + 12, Y + 17)-(X + 16, Y + 5), CoulCoque
    LINE (X + 28, Y + 17)-(X + 24, Y + 5), CoulCoque
    LINE (X + 16, Y + 5)-(X + 24, Y + 5), CoulCoque
    LINE (X + 17, Y + 4)-(X + 23, Y + 4), CoulCoque, BF
    CIRCLE (X + 20, Y + 7), 4, CoulCoque, 3.5, 6, .75
    CIRCLE (X + 20, Y + 12), 8, CoulCoque, 3.5, 6, .75
    PAINT (X + 20, Y + 7), CoulCoque, CoulCoque
    PAINT (X + 20, Y + 30), CoulCoque, CoulCoque

    REM ** Cockpit **
    PAINT (X + 20, Y + 15), CoulVCock, CoulCoque
    LINE (X + 18, Y + 10)-(X + 16, Y + 16), CoulBarre
    LINE (X + 22, Y + 10)-(X + 24, Y + 16), CoulBarre

    REM ** Cabine radar **
    LINE (X + 12, Y + 30)-(X + 9, Y + 35), CoulCR
    LINE (X + 28, Y + 30)-(X + 31, Y + 35), CoulCR
    LINE (X + 12, Y + 30)-(X + 28, Y + 30), CoulCR
    LINE (X + 9, Y + 35)-(X + 31, Y + 35), CoulCR
    PAINT (X + 20, Y + 32), CoulCR, CoulCR

    REM ** Radar **
    LINE (X + 18, Y + 30)-(X + 22, Y + 32), CoulRadar, BF
    CIRCLE (X + 20, Y + 25), 6, CoulRadar, 3.14, 0, .7
    LINE (X + 20, Y + 22)-(X + 20, Y + 28), CoulCable
    LINE (X + 17, Y + 27)-(X + 20, Y + 23), CoulCable
    LINE (X + 23, Y + 27)-(X + 20, Y + 24), CoulCable

    REM ** Canons laser (frontal et latraux) **
    LINE (X + 19, Y)-(X + 21, Y + 3), CoulCR, BF
    LINE (X + 9, Y + 15)-(X + 11, Y + 22), CoulCR, BF
    LINE (X + 29, Y + 15)-(X + 31, Y + 22), CoulCR, BF
    LINE (X + 10, Y + 8)-(X + 10, Y + 14), CoulTige
    LINE (X + 30, Y + 8)-(X + 30, Y + 14), CoulTige
    LINE (X + 10, Y + 23)-(X + 10, Y + 27), CoulCable
    LINE (X + 30, Y + 23)-(X + 30, Y + 27), CoulCable
    LINE (X + 10, Y + 27)-(X + 13, Y + 27), CoulCable
    LINE (X + 30, Y + 27)-(X + 27, Y + 27), CoulCable
    LINE (X + 13, Y + 27)-(X + 13, Y + 29), CoulCable
    LINE (X + 27, Y + 27)-(X + 27, Y + 29), CoulCable

    REM ** Racteurs **
    LINE (X + 8, Y + 41)-(X + 15, Y + 45), CoulCR, BF
    LINE (X + 32, Y + 41)-(X + 25, Y + 45), CoulCR, BF
RETURN


REM ********** Vaisseaux ennemis **********
DessVE:
    IF TypVE = 1 THEN           '** Vaisseau triangulaire **
        IF Direc = 1 THEN        '** Dirig vers la gauche **

            REM ** Canons lance-missile latraux **
            LINE (X + 9, Y + 2)-(X + 14, Y + 4), CoulCR, BF
            LINE (X + 9, Y + 16)-(X + 14, Y + 18), CoulCR, BF
            LINE (X + 3, Y + 3)-(X + 8, Y + 3), 7
            LINE (X + 3, Y + 17)-(X + 8, Y + 17), 7

            REM ** Forme du vaisseau et cockpit **
            LINE (X, Y + 10)-(X + 20, Y), CoulVE
            LINE (X, Y + 10)-(X + 20, Y + 20), CoulVE
            LINE (X + 20, Y)-(X + 20, Y + 20), CoulVE
            LINE (X + 4, Y + 8)-(X + 4, Y + 12), CoulVE
            LINE (X + 9, Y + 5)-(X + 9, Y + 15), CoulVE
            PAINT (X + 2, Y + 10), CoulVE, CoulVE
            PAINT (X + 10, Y + 10), CoulVE, CoulVE
            PAINT (X + 5, Y + 10), CoulVitre, CoulVE

            REM ** Dessin sur le vaisseau **
            LINE (X + 12, Y + 10)-(X + 18, Y + 4), CoulDess
            LINE (X + 12, Y + 10)-(X + 18, Y + 16), CoulDess
            LINE (X + 15, Y + 10)-(X + 18, Y + 7), CoulDess
            LINE (X + 15, Y + 10)-(X + 18, Y + 13), CoulDess
            PSET (X + 18, Y + 10), CoulDess

            REM ** Racteurs **
            LINE (X + 21, Y + 3)-(X + 22, Y + 7), CoulCR, BF
            LINE (X + 21, Y + 13)-(X + 22, Y + 17), CoulCR, BF

        ELSEIF Direc = 2 THEN    '** Dirig vers la droite **

            REM ** Canons lance-missile latraux **
            LINE (X + 13, Y + 2)-(X + 8, Y + 4), CoulCR, BF
            LINE (X + 13, Y + 16)-(X + 8, Y + 18), CoulCR, BF
            LINE (X + 19, Y + 3)-(X + 14, Y + 3), 7
            LINE (X + 19, Y + 17)-(X + 14, Y + 17), 7

            REM ** Forme du vaisseau et cockpit **
            LINE (X + 22, Y + 10)-(X + 2, Y), CoulVE
            LINE (X + 22, Y + 10)-(X + 2, Y + 20), CoulVE
            LINE (X + 2, Y)-(X + 2, Y + 20), CoulVE
            LINE (X + 18, Y + 8)-(X + 18, Y + 12), CoulVE
            LINE (X + 13, Y + 5)-(X + 13, Y + 15), CoulVE
            PAINT (X + 20, Y + 10), CoulVE, CoulVE
            PAINT (X + 12, Y + 10), CoulVE, CoulVE
            PAINT (X + 17, Y + 10), CoulVitre, CoulVE

            REM ** Dessin sur le vaisseau **
            LINE (X + 10, Y + 10)-(X + 4, Y + 4), CoulDess
            LINE (X + 10, Y + 10)-(X + 4, Y + 16), CoulDess
            LINE (X + 7, Y + 10)-(X + 4, Y + 7), CoulDess
            LINE (X + 7, Y + 10)-(X + 4, Y + 13), CoulDess
            PSET (X + 4, Y + 10), CoulDess

            REM ** Racteurs **
            LINE (X, Y + 3)-(X + 1, Y + 7), CoulCR, BF
            LINE (X, Y + 13)-(X + 1, Y + 17), CoulCR, BF
        END IF

    ELSEIF TypVE = 2 THEN       '** Vaisseau arrondi **
        IF Direc = 1 THEN        '** Dirig vers la gauche **

            REM ** Forme du vaisseau **
            CIRCLE (X + 10, Y + 8), 10, CoulVE, .8, 5.48, .75
            LINE (X + 17, Y + 3)-(X + 30, Y + 3), CoulVE
            LINE (X + 17, Y + 13)-(X + 30, Y + 13), CoulVE
            LINE (X + 30, Y + 3)-(X + 30, Y + 13), CoulVE
            CIRCLE (X, Y + 8), 10, CoulVE, 5.48, .8, 1.25
            PAINT (X + 10, Y + 8), CoulVE, CoulVE
            PAINT (X + 2, Y + 8), CoulVitre, CoulVE

            REM ** Canon laser **
            CIRCLE (X + 14, Y + 8), 3, CoulCR
            PAINT (X + 14, Y + 8), CoulCR, CoulCR
            LINE (X + 13, Y + 7)-(X + 15, Y + 9), 0, BF
            LINE (X + 9, Y + 8)-(X + 14, Y + 8), 0

            REM ** Gnrateurs d'nergie du canon **
            LINE (X + 9, Y + 3)-(X + 10, Y + 4), CoulCR, BF
            LINE (X + 9, Y + 12)-(X + 10, Y + 13), CoulCR, BF

            REM ** Dessin sur le vaisseau **
            CIRCLE (X + 24, Y + 8), 4, CoulDess, , , .75
            CIRCLE (X + 24, Y + 8), 2, CoulDess, , , .25

            REM ** Racteur **
            LINE (X + 31, Y + 5)-(X + 32, Y + 11), CoulCR, BF

        ELSEIF Direc = 2 THEN    '** Dirig vers la droite **
      
            REM ** Forme du vaisseau **
            CIRCLE (X + 22, Y + 8), 10, CoulVE, 3.84, 2.34, .75
            LINE (X + 15, Y + 3)-(X + 2, Y + 3), CoulVE
            LINE (X + 15, Y + 13)-(X + 2, Y + 13), CoulVE
            LINE (X + 2, Y + 3)-(X + 2, Y + 13), CoulVE
            CIRCLE (X + 32, Y + 8), 10, CoulVE, 2.34, 3.94, 1.25
            PAINT (X + 22, Y + 8), CoulVE, CoulVE
            PAINT (X + 30, Y + 8), CoulVitre, CoulVE

            REM ** Canon laser **
            CIRCLE (X + 18, Y + 8), 3, CoulCR
            PAINT (X + 18, Y + 8), CoulCR, CoulCR
            LINE (X + 19, Y + 7)-(X + 17, Y + 9), 0, BF
            LINE (X + 23, Y + 8)-(X + 18, Y + 8), 0

            REM ** Gnrateurs d'nergie du canon **
            LINE (X + 23, Y + 3)-(X + 22, Y + 4), CoulCR, BF
            LINE (X + 23, Y + 12)-(X + 22, Y + 13), CoulCR, BF

            REM ** Dessin sur le vaisseau **
            CIRCLE (X + 8, Y + 8), 4, CoulDess, , , .75
            CIRCLE (X + 8, Y + 8), 2, CoulDess, , , .25

            REM ** Racteur **
            LINE (X, Y + 5)-(X + 1, Y + 11), CoulCR, BF

        END IF
    END IF
RETURN


REM ********** Explosion **********
DessBoom:                                        '     _
    CIRCLE (X, Y), 3, 12                         '    /
    CIRCLE (X, Y), 7, 12                         '   |
    LINE (X - 4, Y - 10)-(X, Y - 18), 12         '   |
    LINE (X + 4, Y - 10)-(X, Y - 18), 12         '   |
    LINE (X - 4, Y + 10)-(X, Y + 18), 12         '   |
    LINE (X + 4, Y + 10)-(X, Y + 18), 12         '   |
    LINE (X - 10, Y - 4)-(X - 18, Y), 12         '   |
    LINE (X - 10, Y + 4)-(X - 18, Y), 12         '   |
    LINE (X + 10, Y - 4)-(X + 18, Y), 12         '  /
    LINE (X + 10, Y + 4)-(X + 18, Y), 12         ' <     Orange
    LINE (X - 4, Y - 10)-(X - 14, Y - 14), 12    '  \
    LINE (X - 10, Y - 4)-(X - 14, Y - 14), 12    '   |
    LINE (X + 4, Y - 10)-(X + 14, Y - 14), 12    '   |
    LINE (X + 10, Y - 4)-(X + 14, Y - 14), 12    '   |
    LINE (X - 4, Y + 10)-(X - 14, Y + 14), 12    '   |
    LINE (X - 10, Y + 4)-(X - 14, Y + 14), 12    '   |
    LINE (X + 4, Y + 10)-(X + 14, Y + 14), 12    '   |
    LINE (X + 10, Y + 4)-(X + 14, Y + 14), 12    '   |
    PAINT (X, Y + 5), 12, 12                     '    \_

    PAINT (X, Y), 4, 12          '   <-- Rouge
                                                     
    PAINT (X, Y + 8), 14, 12     '   /
    PSET (X + 13, Y - 13), 14    '  <--- Jaune
    PSET (X + 13, Y + 13), 14    '   \
RETURN



REM ****************************************************
REM ** Affichage et dplacement du vaisseau principal **
REM ****************************************************

REM ********** Affichage **********
AffVaiss:
    GET (XVaiss, YVaiss)-(XVaiss + 40, YVaiss + 45), FondVaiss
    X = XVaiss
    Y = YVaiss
    GOSUB DessVaiss
RETURN


REM ********** Dplacement **********
DplVaiss:
    PUT (XVaiss, YVaiss), FondVaiss, PSET
    IF Direc = 1 THEN               '** Vers la gauche **
        XVaiss = XVaiss - VitDpl
    ELSEIF Direc = 2 THEN           '** Vers la droite **
        XVaiss = XVaiss + VitDpl
    END IF
    GOSUB AffVaiss
RETURN



REM ****************************************************
REM ** Affichage et dplacement des vaisseaux ennemis **
REM ****************************************************

REM ********** Initialisation des couleurs en fonction de la gamme **********
InitClVE:
    SELECT CASE CoulsVE(TypVE, NumVE)
        CASE 1
            CoulVE = 1       'Couleur de la coque :            Bleu
            CoulDess = 14    'Couleur des dessins :            Jaune
            CoulVitre = 7    'Couleur de la vitre du cockpit : Gris clair
        CASE 2
            CoulVE = 2       'Couleur de la coque :            Vert
            CoulDess = 4     'Couleur des dessins :            Rouge
            CoulVitre = 1    'Couleur de la vitre du cockpit : Bleu
        CASE 3
            CoulVE = 3       'Couleur de la coque :            Cyan
            CoulDess = 14    'Couleur des dessins :            Jaune
            CoulVitre = 1    'Couleur de la vitre du cockpit : Bleu
        CASE 4
            CoulVE = 4       'Couleur de la coque :            Rouge
            CoulDess = 14    'Couleur des dessins :            Jaune
            CoulVitre = 9    'Couleur de la vitre du cockpit : Bleu clair
        CASE 5
            CoulVE = 10      'Couleur de la coque :            Vert clair
            CoulDess = 4     'Couleur des dessins :            Rouge
            CoulVitre = 9    'Couleur de la vitre du cockpit : Bleu clair
        CASE 6
            CoulVE = 11      'Couleur de la coque :            Cyan clair
            CoulDess = 4     'Couleur des dessins :            Rouge
            CoulVitre = 9    'Couleur de la vitre du cockpit : Bleu clair
    END SELECT
RETURN


REM ********** Affichage **********
AffVE:
    X = XVE(TypVE, NumVE)
    Y = YVE(TypVE, NumVE)
    IF TypVE = 1 THEN
        SELECT CASE NumVE
            CASE 1: GET (XVE(1, 1), Y)-(XVE(1, 1) + 22, Y + 20), FondVE1.1
            CASE 2: GET (XVE(1, 2), Y)-(XVE(1, 2) + 22, Y + 20), FondVE1.2
            CASE 3: GET (XVE(1, 3), Y)-(XVE(1, 3) + 22, Y + 20), FondVE1.3
        END SELECT
    ELSEIF TypVE = 2 THEN
        SELECT CASE NumVE
            CASE 1: GET (XVE(2, 1), Y)-(XVE(2, 1) + 32, Y + 16), FondVE2.1
            CASE 2: GET (XVE(2, 2), Y)-(XVE(2, 2) + 32, Y + 16), FondVE2.2
            CASE 3: GET (XVE(2, 3), Y)-(XVE(2, 3) + 32, Y + 16), FondVE2.3
        END SELECT
    END IF
    Direc = DirVE(TypVE, NumVE)
    GOSUB InitClVE
    GOSUB DessVE
RETURN


REM ********** Effacement **********
EffVE:
    IF TypVE = 1 THEN
        SELECT CASE NumVE
            CASE 1: PUT (XVE(1, 1), YVE(1, 1)), FondVE1.1, PSET
            CASE 2: PUT (XVE(1, 2), YVE(1, 2)), FondVE1.2, PSET
            CASE 3: PUT (XVE(1, 3), YVE(1, 3)), FondVE1.3, PSET
        END SELECT
    ELSEIF TypVE = 2 THEN
        SELECT CASE NumVE
            CASE 1: PUT (XVE(2, 1), YVE(2, 1)), FondVE2.1, PSET
            CASE 2: PUT (XVE(2, 2), YVE(2, 2)), FondVE2.2, PSET
            CASE 3: PUT (XVE(2, 3), YVE(2, 3)), FondVE2.3, PSET
        END SELECT
    END IF
RETURN


REM ********** Dplacement **********
DplVE:
    GOSUB EffVE
    Direc = DirVE(TypVE, NumVE)
    IF Direc = 1 THEN        '** Vers la gauche **
        XVE(TypVE, NumVE) = XVE(TypVE, NumVE) - VitDpl
    ELSEIF Direc = 2 THEN    '** Vers la droite **
        XVE(TypVE, NumVE) = XVE(TypVE, NumVE) + VitDpl
    END IF
    GOSUB AffVE
RETURN



REM *********************************************
REM ** Affichage et effacement d'une explosion **
REM *********************************************

REM ********** Calcul de l'abscisse **********
ClcAbscis:
    X = XBoom(NumBoom)
    Y = YBoom(NumBoom)
    IF X - 18 < 0 THEN         '** L'explosion sort de l'cran  gauche **
        XGauche = 0
        XDroite = X + 18
    ELSEIF X + 18 > 639 THEN   '** L'explosion sort de l'cran  droite **
        XGauche = X - 18
        XDroite = 639
    ELSE                       '** L'explosion est entirement dans l'cran **
        XGauche = X - 18
        XDroite = X + 18
    END IF
RETURN


REM ********** Affichage **********
AffBoom:
    GOSUB ClcAbscis
    SELECT CASE NumBoom
        CASE 1: GET (XGauche, Y - 18)-(XDroite, Y + 18), FondBoom1
        CASE 2: GET (XGauche, Y - 18)-(XDroite, Y + 18), FondBoom2
        CASE 3: GET (XGauche, Y - 18)-(XDroite, Y + 18), FondBoom3
        CASE 4: GET (XGauche, Y - 18)-(XDroite, Y + 18), FondBoom4
        CASE 5: GET (XGauche, Y - 18)-(XDroite, Y + 18), FondBoom5
        CASE 6: GET (XGauche, Y - 18)-(XDroite, Y + 18), FondBoom6
    END SELECT
    GOSUB DessBoom
RETURN


REM ********** Effacement **********
EffBoom:
    GOSUB ClcAbscis
    SELECT CASE NumBoom
        CASE 1: PUT (XGauche, Y - 18), FondBoom1, PSET
        CASE 2: PUT (XGauche, Y - 18), FondBoom2, PSET
        CASE 3: PUT (XGauche, Y - 18), FondBoom3, PSET
        CASE 4: PUT (XGauche, Y - 18), FondBoom4, PSET
        CASE 5: PUT (XGauche, Y - 18), FondBoom5, PSET
        CASE 6: PUT (XGauche, Y - 18), FondBoom6, PSET
    END SELECT
    LnOccup(LnBoom(NumBoom)) = 0
    NbBoom = NbBoom - 1
RETURN



REM *********
REM ** Tir **
REM *********

REM ********** Tir du vaisseau **********
Tir:
    REM ** Vrifie si des vaisseaux ennemis sont touchs **
    VaissTouch = 0
    FOR I = 1 TO 2        '** I correspond ici  TypVE (type du vaisseau) **
        IF I = 1 THEN Larg = 0:  ELSE Larg = 10
        FOR J = 1 TO 3    '** J correspond ici  NumVE (numro du vaisseau) **
            IF (ActVE(I, J) = 1) AND (XVaiss + 18 >= XVE(I, J)) AND (XVaiss <= XVE(I, J) + Larg) THEN
                REM ** Le laser touche le vaisseau **
                IF VaissTouch = 0 THEN VaissTouch = 1
                VieVE(I, J) = VieVE(I, J) - 1
               
                REM ** Vrifie s'il reste des points de vie au vaisseau **
                IF VieVE(I, J) = 0 THEN
                    REM ** Efface le vaisseau et le dsactive **
                    VaissTouch = 2
                    TypVE = I
                    NumVE = J
                    GOSUB EffVE
                    ActVE(I, J) = 0
                   
                    REM ** Affiche une explosion **
                    NbBoom = NbBoom + 1
                    NumBoom = NbBoom
                    CmptBoom(NumBoom) = 5
                    LnBoom(NumBoom) = LnVE(I, J)
                    IF TypVE = 1 THEN
                        XBoom(NumBoom) = XVE(1, J) + 11
                        YBoom(NumBoom) = YVE(1, J) + 10
                    ELSE
                        XBoom(NumBoom) = XVE(2, J) + 16
                        YBoom(NumBoom) = YVE(2, J) + 8
                    END IF
                    GOSUB AffBoom
               
                    REM ** Augmente le score et l'affiche **
                    Score = Score + 10 + VitVE(I, J)
                    GOSUB AffScore
                END IF
            END IF
        NEXT
    NEXT

    REM ** Affiche le rayon laser **
    GET (XVaiss + 20, 40)-(XVaiss + 20, YVaiss - 1), FondLaser
    LINE (XVaiss + 20, 40)-(XVaiss + 20, YVaiss - 1), 4

    REM ** Cre un effet sonore selon le cas **
    IF VaissTouch = 0 THEN        '** Aucun vaisseau n'est touch **
        SOUND 380, 2
        FOR I = 380 TO 280 STEP -20: SOUND I, .25: NEXT
    ELSEIF VaissTouch = 1 THEN    '** Au moins un vaisseau est touch **
        FOR I = 34 TO 30 STEP -1: SOUND I * 5, .5: NEXT
    ELSEIF VaissTouch = 2 THEN    '** Au moins un vaisseau a explos **
        FOR I = 10 TO 4 STEP -1: SOUND I * 10, .5: NEXT
        FOR I = 5 TO 4 STEP -1: SOUND I * 10, 1: NEXT
    END IF

    REM ** Efface le laser **
    PUT (XVaiss + 20, 40), FondLaser, PSET
RETURN


REM ********** Affichage du score **********
AffScore:
    COLOR 15
    LOCATE 2, 12
    PRINT Score
RETURN



REM *******************
REM ** Temporisation **
REM *******************

REM ********** Relev du temps **********
RlvTemps:
    Temps = TIMER
    IF Temps < TmpDebut THEN TmpDebut = TmpDebut - 86400
    Temps = Temps - TmpDebut
RETURN


REM ********** Affichage du temps coul **********
AffTemps:
    REM ** Rcupration des minutes, secondes et diximes **
    TpsEnt = FIX(Temps)
    Dixiemes = FIX((Temps - TpsEnt) * 10)
    Secondes = TpsEnt MOD 60
    TpsEnt = TpsEnt \ 60
    Minutes = TpsEnt MOD 60
   
    REM ** Affichage des minutes **
    COLOR 15
    IF Minutes < 10 THEN
        LOCATE 2, 70
        PRINT Minutes
        LOCATE 2, 70
        PRINT "0"
    ELSE
        LOCATE 2, 69
        PRINT Minutes
    END IF

    REM ** Affichage des secondes **
    IF Secondes < 10 THEN
        LOCATE 2, 73
        PRINT Secondes
        LOCATE 2, 73
        PRINT "0"
    ELSE
        LOCATE 2, 72
        PRINT Secondes
    END IF
    LOCATE 2, 72
    PRINT ":"

    REM ** Affichage des diximes **
    LOCATE 2, 75
    PRINT Dixiemes
    LOCATE 2, 75
    PRINT ":"
RETURN


       


REM **************************************************************************
REM **************************************************************************
REM ****                                                                  ****
REM ****                         PARTIE PRINCIPALE                        ****
REM ****                                                                  ****
REM **************************************************************************
REM **************************************************************************


REM ***************************
REM ** Ecran de prsentation **
REM ***************************

Present:
SCREEN 0
WIDTH 80, 25
CLS
TempsDebut = TIMER
Temps2 = 0

DO    '** Boucle tant que l'utilisateur n'appuie pas sur une touche **
    REM ** Affichage du titre du jeu en couleur alatoire **
    COLOR FIX(RND * 15) + 1
    LOCATE 3, 1, 0
    PRINT "                                        "
    PRINT "                                                   "
    PRINT "                                                   "
    PRINT "                                           "
    PRINT "                                                   "
    PRINT "                                                 "
    PRINT "                                     "
    LOCATE 12, 1, 0
    PRINT "                                    "
    PRINT "                                                   "
    PRINT "                                                    "
    PRINT "                                            "
    PRINT "                                              "
    PRINT "                                                   "
    PRINT "                                  "
   
    REM ** Affichage du sous-titre **
    COLOR 1
    LOCATE 21, 12, 0
    PRINT "EXEMPLE DE PROGRAMME - COURS DE PROGRAMMATION EN QBASIC"
    COLOR 15
    LOCATE 22, 28, 0
    PRINT "par PHILIPPE-HENRY MARCY"
    COLOR 4
    LOCATE 23, 24, 0
    PRINT "http://membres.lycos.fr/firesnk/"

    REM ** Attend un peu pour viter que l'affichage scintille **
    DO: GOSUB RlvTemps: LOOP UNTIL Temps - Temps2 >= .1
    Temps2 = Temps
LOOP UNTIL INKEY$ <> ""



REM ********************
REM ** Menu principal **
REM ********************

Menu:
SCREEN 0
COLOR 0, 0
CLS


REM ********** Affichage de la fentre **********
LOCATE 5, 11
COLOR 15, 1
PRINT "ͻ"
FOR I = 6 TO 19
    LOCATE I, 11
    PRINT "                                                          "
NEXT
LOCATE 20, 11
PRINT "ͼ"


REM ********** Affichage du menu **********
REM ** Titre **
COLOR 14
LOCATE 8, 33
PRINT "MENU PRINCIPAL"
LOCATE 9, 33
PRINT ""

REM ** Numro des commandes **
COLOR 2
LOCATE 12, 20
PRINT "1:"
LOCATE 14, 20
PRINT "2:"
LOCATE 16, 20
PRINT "3:"

REM ** Commandes **
COLOR 15
LOCATE 12, 23
PRINT "Nouveau jeu"
LOCATE 14, 23
PRINT "Voir commandes"
LOCATE 16, 23
PRINT "Quitter"


REM ********** Attend que l'utilisateur choisisse une commande **********
DO: Touche$ = INKEY$: LOOP UNTIL (Touche$ = "1") OR (Touche$ = "2") OR (Touche$ = "3")

IF Touche$ = "3" THEN    '** "Quitter" **
    GOTO Fin
ELSE
    REM ** Effacement de la fentre **
    LOCATE 8, 33
    PRINT "              "
    LOCATE 9, 33
    PRINT "              "
    LOCATE 12, 20
    PRINT "              "
    LOCATE 14, 20
    PRINT "                 "
    LOCATE 16, 20
    PRINT "          "

    IF Touche$ = "2" THEN    '** "Voir commandes" **
        REM ** Affichage du titre **
        COLOR 14
        LOCATE 7, 35
        PRINT "COMMANDES"
        LOCATE 8, 35
        PRINT ""

        REM ** Affichage des touches **
        COLOR 2
        LOCATE 10, 14
        PRINT CHR$(27); " et "; CHR$(26);
        LOCATE 12, 14
        PRINT "CTRL "; CHR$(27); " et CTRL "; CHR$(26);
        LOCATE 14, 14
        PRINT "ESPACE"
        LOCATE 16, 14
        PRINT "P"
        LOCATE 18, 14
        PRINT "ECHAP"
       
        REM ** Affichage des commandes **
        COLOR 15
        LOCATE 10, 21
        PRINT ": Dplacer le vaisseau"
        LOCATE 12, 31
        PRINT ": Dplacer le vaisseau rapidement"
        LOCATE 14, 21
        PRINT ": Tirer (avec le canon laser frontal)"
        LOCATE 16, 16
        PRINT ": Mettre le jeu en pause"
        LOCATE 18, 20
        PRINT ": Revenir au menu principal"
       
        REM ** Attend que l'utilisateur appuie sur une touche et revient **
        SLEEP
        Touche$ = INKEY$
        GOTO Menu

    ELSE    '** Option "Nouveau jeu"
        REM ** Affichage du titre **
        COLOR 14
        LOCATE 7, 35
        PRINT "NOUVEAU JEU"
        LOCATE 8, 35
        PRINT ""

        REM ** Demande le niveau de difficult **
        COLOR 15
        LOCATE 12, 14
        PRINT "Veuillez choisir un niveau de difficult (1-5) :"
        COLOR 2
        LOCATE 12, 63
        PRINT "  "
        LOCATE 12, 63, 1, 0, 15    '** On positionne le curseur
        Diff = 0
        DO
            DO: Touche$ = INKEY$: LOOP UNTIL Touche$ <> ""
            SELECT CASE Touche$
                CASE "1": Diff = 1
                CASE "2": Diff = 2
                CASE "3": Diff = 3
                CASE "4": Diff = 4
                CASE "5": Diff = 5
            END SELECT

            REM ** Affiche le chiffre entr par l'utilisateur **
            IF Diff > 0 THEN
                LOCATE 12, 63
                PRINT Touche$
                LOCATE 12, 64
                DO: Touche$ = INKEY$: LOOP UNTIL (Touche$ = CHR$(13)) OR (Touche$ = CHR$(8))

                REM ** Vrifie si l'utilisateur a appuy sur Retour arrire **
                IF Touche$ = CHR$(8) THEN
                    REM ** Supprime le chiffre dj entr
                    LOCATE 12, 63
                    PRINT "  "
                    LOCATE 12, 63
                    Diff = 0
                END IF
            END IF
        LOOP UNTIL Diff > 0

        REM ** Prt  lancer le jeu **
        COLOR 15
        LOCATE 18, 14
        PRINT "Appuyez sur une touche pour lancer le jeu..."
        SLEEP
        Touche$ = INKEY$
    END IF
END IF



REM *********************************
REM ** Affichage de l'cran de jeu **
REM *********************************

REM ********** Console **********
SCREEN 12
LINE (0, 0)-(639, 39), 4, B
LINE (1, 1)-(638, 38), 12, B
LINE (2, 2)-(637, 37), 14, B
COLOR 15
LOCATE 2, 5
PRINT "Score : 0"
LOCATE 2, 62
PRINT "Temps : 00:00:0"
 

REM ********** Dcor (toiles) **********
FOR I = 1 TO 500
    X = FIX(RND * 640)
    Y = FIX(RND * 440) + 40
    Couleur = FIX(RND * 7)
    SELECT CASE Couleur
        CASE 0: Couleur = 5
        CASE 1: Couleur = 6
        CASE 2: Couleur = 7     '** Seulement 7 couleurs disponibles (pour
        CASE 3: Couleur = 9     '   viter les problmes avec les commandes
        CASE 4: Couleur = 13    '   PAINT des sous-routines de dessin) **
        CASE 5: Couleur = 14
        CASE 6: Couleur = 15
    END SELECT
    PSET (X, Y), Couleur
NEXT


REM ********** Demande  l'utilisateur s'il est prt **********
COLOR 1
LOCATE 2, 36
PRINT "PRETS ?"
SLEEP
Touche$ = INKEY$
LOCATE 2, 36
PRINT "       "



REM *********
REM ** Jeu **
REM *********

REM ********** Initialisation des variables **********
REM ** Donnes du vaisseau principal **
XVaiss = 299
CmptTir = 0
GOSUB AffVaiss

REM ** Donnes des vaisseaux ennemis **
FOR I = 1 TO 3
    ActVE(1, I) = 0
    ActVE(2, I) = 0
NEXT
CmptActVE = 0
  
REM ** Lignes occupes par des vaisseaux ennemis **
FOR I = 1 TO 8: LnOccup(I) = 0: NEXT
  
REM ** Donnes des explosions **
NbBoom = 0
FOR I = 1 TO 6: CmptBoom(I) = 0: NEXT
  
REM ** Autres **
Score = 0
Temps2 = 0
TmpDebut = TIMER


REM ********** Boucle principale **********
Jeu:
    REM ** Vrifie si l'utilisateur a appuy sur une touche **
    Touche$ = INKEY$
    SELECT CASE Touche$
        CASE CHR$(0) + CHR$(75):    '** Dplacement simple vers la gauche **
            IF XVaiss >= 10 THEN    ' (Touche Droite)
                VitDpl = 10
                Direc = 1
                GOSUB DplVaiss
            END IF
        CASE CHR$(0) + CHR$(77):    '** Dplacement simple vers la droite **
            IF XVaiss <= 589 THEN   ' (Touche Droite)
                VitDpl = 10
                Direc = 2
                GOSUB DplVaiss
            END IF
        CASE CHR$(0) + CHR$(115):   '** Dplacement acclr vers la gauche **
            IF XVaiss >= 25 THEN    ' (Touches CTRL + Gauche)
                VitDpl = 25
                Direc = 1
                GOSUB DplVaiss
            END IF
        CASE CHR$(0) + CHR$(116):   '** Dplacement acclr vers la droite **
            IF XVaiss <= 574 THEN   ' (Touches CTRL + Droite)
                VitDpl = 25
                Direc = 2
                GOSUB DplVaiss
            END IF
        CASE CHR$(32):              '** Tir avec le canon laser frontal **
            IF CmptTir = 0 THEN     ' (Touche ESPACE)
                GOSUB Tir
                CmptTir = 4 + Diff
            END IF
        CASE "p", "P":              '** Met le jeu en pause **
            LOCATE 2, 37            ' (Touche P)
            COLOR 1
            PRINT "PAUSE"

            REM ** Relve le temps avant et aprs la pause **
            GOSUB RlvTemps
            Temps2 = Temps
            DO: LOOP UNTIL (INKEY$ = "p") OR (INKEY$ = "P")
            GOSUB RlvTemps

            REM ** Soustrait le temps qui s'est coul pendant la pause **
            TmpDebut = TmpDebut + (Temps - Temps2)

            LOCATE 2, 37
            PRINT "     "
        CASE CHR$(27): GOTO Menu    '** Revient au menu principal **
    END SELECT                      ' (Touche ECHAP)

    REM ** Temporisation **
    GOSUB RlvTemps
    IF Temps - Temps2 >= .1 THEN
        Temps2 = Temps
        GOSUB AffTemps

        REM ** Activation alatoire des vaisseaux ennemis **
        CmptActVE = CmptActVE + 1
        IF CmptActVE = 5 THEN
            CmptActVE = 0

            REM ** Choisit le vaisseau au hasard **
            TypVE = FIX(RND * 2) + 1
            NumVE = FIX(RND * 3) + 1
            NumLigne = FIX(RND * 8) + 1

            REM ** Vrifie s'il est possible d'activer le vaisseau **
            IF (ActVE(TypVE, NumVE) = 0) AND (LnOccup(NumLigne) = 0) THEN
                REM ** Initialise les donnes du vaisseau **
                LnVE(TypVE, NumVE) = NumLigne
                LnOccup(NumLigne) = 1
                ActVE(TypVE, NumVE) = 1
                VieVE(TypVE, NumVE) = 1 + Diff \ 2
                VitVE(TypVE, NumVE) = FIX(RND * 5) + 1
                CoulsVE(TypVE, NumVE) = FIX(RND * 6) + 1
                DirVE(TypVE, NumVE) = FIX(RND * 2) + 1

                IF DirVE(TypVE, NumVE) = 1 THEN
                    XVE(TypVE, NumVE) = XMaxVE(TypVE)
                ELSEIF DirVE(TypVE, NumVE) = 2 THEN
                    XVE(TypVE, NumVE) = 0
                END IF
                YVE(TypVE, NumVE) = 10 + NumLigne * 40

                REM ** Affiche le vaisseau **
                GOSUB AffVE
            END IF
        END IF

        REM ** Dplace les vaisseaux et vrifie s'ils sont en bout d'cran **
        FOR TypVE = 1 TO 2
            FOR NumVE = 1 TO 3
                IF ActVE(TypVE, NumVE) = 1 THEN    '** Vaisseau activ **
                    VitDpl = 5 + Diff + VitVE(TypVE, NumVE)
                    IF DirVE(TypVE, NumVE) = 1 THEN      '** Vers la gauche **
                        IF XVE(TypVE, NumVE) >= VitDpl THEN
                            GOSUB DplVE
                        ELSE   '** Le vaisseau a atteint le bord de l'cran **
                            GOSUB EffVE
                            ActVE(TypVE, NumVE) = 0
                            LnOccup(LnVE(TypVE, NumVE)) = 0
                        END IF
                    ELSEIF DirVE(TypVE, NumVE) = 2 THEN  '** Vers la droite **
                        IF XVE(TypVE, NumVE) <= XMaxVE(TypVE) - VitDpl THEN
                            GOSUB DplVE
                        ELSE   '** Le vaisseau a atteint le bord de l'cran **
                            GOSUB EffVE
                            ActVE(TypVE, NumVE) = 0
                            LnOccup(LnVE(TypVE, NumVE)) = 0
                        END IF
                    END IF
                END IF
            NEXT
        NEXT
   
        REM ** Efface les explosions dont le temps d'affichage s'est coul **
        FOR I = 1 TO 6
            IF CmptBoom(I) > 0 THEN
                CmptBoom(I) = CmptBoom(I) - 1
                IF CmptBoom(I) = 0 THEN
                    NumBoom = I
                    GOSUB EffBoom
                END IF
            END IF
        NEXT
       
        REM ** Diminue le temps restant avant l'activation du laser **
        IF CmptTir > 0 THEN CmptTir = CmptTir - 1
    END IF

GOTO Jeu



REM **********************
REM ** Fin du programme **
REM **********************

Fin:
SCREEN 0
COLOR 7, 0



